// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// - protoc-gen-go-grpc v1.3.0
// - protoc             v3.20.3
// source: proto/monitor.proto

package interfaces

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	Listener_Monitor_FullMethodName       = "/listener.Listener/Monitor"
	Listener_ListServices_FullMethodName  = "/listener.Listener/ListServices"
	Listener_CurrentStatus_FullMethodName = "/listener.Listener/CurrentStatus"
)

// ListenerClient is the client API for Listener service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ListenerClient interface {
	Monitor(ctx context.Context, in *MonitorRequest, opts ...grpc.CallOption) (Listener_MonitorClient, error)
	ListServices(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ServicesResponse, error)
	CurrentStatus(ctx context.Context, in *MonitorRequest, opts ...grpc.CallOption) (*MonitorResponse, error)
}

type listenerClient struct {
	cc grpc.ClientConnInterface
}

func NewListenerClient(cc grpc.ClientConnInterface) ListenerClient {
	return &listenerClient{cc}
}

func (c *listenerClient) Monitor(ctx context.Context, in *MonitorRequest, opts ...grpc.CallOption) (Listener_MonitorClient, error) {
	stream, err := c.cc.NewStream(ctx, &Listener_ServiceDesc.Streams[0], Listener_Monitor_FullMethodName, opts...)
	if err != nil {
		return nil, err
	}
	x := &listenerMonitorClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Listener_MonitorClient interface {
	Recv() (*MonitorResponse, error)
	grpc.ClientStream
}

type listenerMonitorClient struct {
	grpc.ClientStream
}

func (x *listenerMonitorClient) Recv() (*MonitorResponse, error) {
	m := new(MonitorResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *listenerClient) ListServices(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ServicesResponse, error) {
	out := new(ServicesResponse)
	err := c.cc.Invoke(ctx, Listener_ListServices_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *listenerClient) CurrentStatus(ctx context.Context, in *MonitorRequest, opts ...grpc.CallOption) (*MonitorResponse, error) {
	out := new(MonitorResponse)
	err := c.cc.Invoke(ctx, Listener_CurrentStatus_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ListenerServer is the server API for Listener service.
// All implementations must embed UnimplementedListenerServer
// for forward compatibility
type ListenerServer interface {
	Monitor(*MonitorRequest, Listener_MonitorServer) error
	ListServices(context.Context, *emptypb.Empty) (*ServicesResponse, error)
	CurrentStatus(context.Context, *MonitorRequest) (*MonitorResponse, error)
	mustEmbedUnimplementedListenerServer()
}

// UnimplementedListenerServer must be embedded to have forward compatible implementations.
type UnimplementedListenerServer struct {
}

func (UnimplementedListenerServer) Monitor(*MonitorRequest, Listener_MonitorServer) error {
	return status.Errorf(codes.Unimplemented, "method Monitor not implemented")
}
func (UnimplementedListenerServer) ListServices(context.Context, *emptypb.Empty) (*ServicesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListServices not implemented")
}
func (UnimplementedListenerServer) CurrentStatus(context.Context, *MonitorRequest) (*MonitorResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CurrentStatus not implemented")
}
func (UnimplementedListenerServer) mustEmbedUnimplementedListenerServer() {}

// UnsafeListenerServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ListenerServer will
// result in compilation errors.
type UnsafeListenerServer interface {
	mustEmbedUnimplementedListenerServer()
}

func RegisterListenerServer(s grpc.ServiceRegistrar, srv ListenerServer) {
	s.RegisterService(&Listener_ServiceDesc, srv)
}

func _Listener_Monitor_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(MonitorRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ListenerServer).Monitor(m, &listenerMonitorServer{stream})
}

type Listener_MonitorServer interface {
	Send(*MonitorResponse) error
	grpc.ServerStream
}

type listenerMonitorServer struct {
	grpc.ServerStream
}

func (x *listenerMonitorServer) Send(m *MonitorResponse) error {
	return x.ServerStream.SendMsg(m)
}

func _Listener_ListServices_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ListenerServer).ListServices(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Listener_ListServices_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ListenerServer).ListServices(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Listener_CurrentStatus_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(MonitorRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ListenerServer).CurrentStatus(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Listener_CurrentStatus_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ListenerServer).CurrentStatus(ctx, req.(*MonitorRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Listener_ServiceDesc is the grpc.ServiceDesc for Listener service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Listener_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "listener.Listener",
	HandlerType: (*ListenerServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ListServices",
			Handler:    _Listener_ListServices_Handler,
		},
		{
			MethodName: "CurrentStatus",
			Handler:    _Listener_CurrentStatus_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Monitor",
			Handler:       _Listener_Monitor_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "proto/monitor.proto",
}
